<!--#include virtual="/.narodsys/metrika_counter.html"-->
<i style="background:url(//www.tns-counter.ru/V13a****yandex_ru/ru/CP1251/tmsec=narod_total/0)"></i>
<!--#include virtual="/.narodsys/direct.html"-->
/*****************************************************************************

line_perp_to_face_32.cpp

	  2008.
	 ..,  ..  

	 ()    
		"      "
      
       ,  (   ),
	   ,    .

	        ,  
	    .
 

*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>



#include <uf.h>
#include <uf_ui.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_modl.h>
#include <uf_curve.h>
#include <uf_disp.h>
#include <uf_part.h>
#include <uf_vec.h>
#include <uf_mtx.h>
#include <uf_csys.h>

static	FILE*	prterr;
static	int		errorCode;
static tag_t	parent_part;



//   
#define	PRTERR if(errorCode){PrintErrorMessage(errorCode,__LINE__);goto term;}



//   
static	void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"\n	errorCode=%d	message=%s	line=%d\n",errorCode,message,line);
		
	}
}//PrintErrorMessage




//   
static int init_proc_face(UF_UI_selection_p_t select, void* user_data)
{

	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_face_type,0,0};

	errorCode=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples,mask_triples);

	if(errorCode==0)
		return(UF_UI_SEL_SUCCESS);
	else
		return(UF_UI_SEL_FAILURE);

}


//   
static int	init_proc_point(UF_UI_selection_p_t select, void* user_data)
{
	int				num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_point_type,0,0};

	errorCode=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples,mask_triples);
	if(errorCode==0)
		return	UF_UI_SEL_SUCCESS;
	else
		return	UF_UI_SEL_FAILURE;
}






// 
int	do_it(void)
{	
	tag_t	face_id=NULL_TAG;
	int		selection_flag;
	int		points_bag_count;
	double	points_bag[1000][3];
	double	face_parms_bag[1000][2];
	double	unit_norm_bag[1000][3];	
	double	segm_length;



	select_face:

	{// 
		char	cue[]=" ";
		char	title[]=" ";
		int		response;
		tag_t	object=NULL_TAG,view;
		double	cursor[3];
		
		errorCode=UF_UI_select_with_single_dialog(cue,title,UF_UI_SEL_SCOPE_NO_CHANGE,
			init_proc_face,NULL,&response,&object,cursor,&view);
		PRTERR;
		
		switch(response)
		{
		case	UF_UI_BACK:		fprintf(prterr,"user selected BACK	line=%d\n",__LINE__);goto select_face;
		case	UF_UI_CANCEL:	fprintf(prterr,"user selected CANCEL	line=%d\n",__LINE__);
								goto term;
		case	UF_UI_OK:		goto select_face;
		case	UF_UI_OBJECT_SELECTED:				fprintf(prterr,"user selected OBJECT_SELECTED	line=%d\n",__LINE__);break;
		case	UF_UI_OBJECT_SELECTED_BY_NAME:	   fprintf(prterr,"user selected SELECTED_BY_NAME	line=%d\n",__LINE__); break;
		}

		face_id=object;

	}// 





	selection_type:

	{//  
		char*	cp1="   ?";
		int		ip2=1;
		char	cp3[][38]={"  ","  "};
		int		ip4=2;
		
		errorCode=uc1603(cp1,ip2,cp3,ip4);
		switch(errorCode)
		{
		case	1:	errorCode=UF_DISP_set_highlight(face_id,0);	//Back
					PRTERR;
					goto select_face;
		case	2:	fprintf(prterr,"user selected CANCEL	line=%d\n",__LINE__);
					goto term;
		case	5:	selection_flag=5;   //fprintf(prterr,"    selection_flag=5\n");
					break;
		case	6:	selection_flag=6;	//fprintf(prterr,"   selection_flag=6\n");
					break;
		case	19:	fprintf(prterr,
					"selection_flag=19  Disallowed state, unable to bring up dialog	line=%d\n",__LINE__);
					goto term;
		}

	}//  




	//   
	if(selection_flag==5)
	{
		int	i;
		char*	cp1="  -  CANCEL";
		int		ia2[]={4,0};
		int		ip3=0;
		double	rr4[3];

		for(i=0;i<1000;i++)
		{
			errorCode=uc1616(cp1,ia2,ip3,rr4);
			switch(errorCode)
			{
			case	1:	UF_DISP_refresh();
						goto selection_type;
			case	2:	points_bag_count=i;
						UF_DISP_refresh();
						goto	ask_face_parm;
			case	5:	UF_VEC3_copy(rr4,points_bag[i]);
						break;
			case	7:	fprintf(prterr,"no active part		line=%d\n",__LINE__);
						goto term;
			case	8:	fprintf(prterr,"Disallowed state, unable to bring up dialog	line=%d\n",__LINE__);
						goto term;
			}
		}
		goto term;
	}//   


	//  
	if(selection_flag==6)
	{
		char*	message="  ";
		char*	title="  ";
		int		scope=UF_UI_SEL_SCOPE_WORK_PART_AND_OCC;
		void*	user_data=NULL;
		int		response;
		int		count;
		tag_t*	object;
		int		i;

		errorCode=UF_UI_select_with_class_dialog(message,title,scope,init_proc_point,
			user_data,&response,&count,&object);
		PRTERR;

		switch(response)
		{
		case	UF_UI_BACK:	
							for(i=0;i<count;i++)
								{
									errorCode=UF_DISP_set_highlight(object[i],0);
									PRTERR;
								}
							UF_free(object);
							goto selection_type;

		case	UF_UI_CANCEL:
								fprintf(prterr,"user selected CANCEL	line=%d\n",__LINE__);
								goto term;

		case	UF_UI_OK:		break;
		}
		

		for(i=0;i<count;i++)
		{//   
			errorCode=UF_CURVE_ask_point_data(object[i],points_bag[i]);
			PRTERR;			
		}


		for(i=0;i<count;i++)
		{//   
			errorCode=UF_DISP_set_highlight(object[i],0);
			PRTERR;
		}

		UF_free(object);

		points_bag_count=count;
		goto ask_face_parm;

	}//  






	ask_face_parm:

	{//    ;     
		int	i;
		double	u1[3],v1[3],u2[3],v2[3],radii[2];


		for(i=0;i<points_bag_count;i++)
		{
			errorCode=UF_MODL_ask_face_parm(face_id,points_bag[i],face_parms_bag[i],points_bag[i]);
			PRTERR;
		}

	    for(i=0;i<points_bag_count;i++)
		{
			errorCode=UF_MODL_ask_face_props(face_id,face_parms_bag[i],points_bag[i],
											u1,v1,u2,v2,unit_norm_bag[i],radii);
			PRTERR;
		}
	
	
	}//  



	


	disp_conehead:
		{//   
			char*	cp1="  ";
			int		ip2=1;
			char	cp3[][38]={" "," "};
			int		ip4=2;
			int		i;

			conehead:
				UF_DISP_refresh();

			for(i=0;i<points_bag_count;i++)
							UF_DISP_conehead(UF_DISP_ALL_VIEWS_BUT_DRAWING,points_bag[i],
											unit_norm_bag[i],0);

			errorCode=uc1603(cp1,ip2,cp3,ip4);
			switch(errorCode)
				{
					case	1:	UF_DISP_refresh();
								goto	selection_type;
					case	2:	fprintf(prterr,"user selected CANCEL	line=%d\n",__LINE__);
								goto term;
					case	5:	break;
					case	6:	for(i=0;i<points_bag_count;i++)
										UF_VEC3_negate(unit_norm_bag[i],unit_norm_bag[i]);
					
								UF_DISP_refresh();
								goto conehead;
					case	19:	fprintf(prterr,"Disallowed state, unable to bring up dialog	 line=%d\n",
										__LINE__);
				}
		}//   



		{//  
			char*	cp1="  ";
			char	cp2[1][16]={" "};
			int		ip3=1;
			double	ra4[1]={10.0};
			int		ip5;
	
			errorCode=uc1609(cp1,cp2,ip3,ra4,&ip5);
			switch(errorCode)
				{
					case	1:	goto disp_conehead;
					case	2:	fprintf(prterr,"user selected CANCEL	line=%d\n",__LINE__);
								goto term;
					case	3:	break;
					case	4:	break;
					case	8:	fprintf(prterr,"Disallowed state, unable to bring up dialog	line=%d\n",
																								__LINE__);
								goto	term;
				}
			segm_length=ra4[0];
		}//  


		
		{// 
			UF_CURVE_line_t	line_coords;
			tag_t			line;
			int				i;

			for(i=0;i<points_bag_count;i++)
				{
					UF_VEC3_linear_comb(1.0,points_bag[i],segm_length,
											unit_norm_bag[i],line_coords.end_point);
					UF_VEC3_copy(points_bag[i],line_coords.start_point);
			
					errorCode=UF_CURVE_create_line(&line_coords,&line);
					PRTERR;

				}
			UF_DISP_refresh();
			goto selection_type;
		}// 



term:

	//   
	errorCode=UF_DISP_set_highlight(face_id,0);PRTERR;
	UF_DISP_refresh();

return errorCode;
}//do_it()


/*****************************************************************************
**  Activation Methods
*****************************************************************************/
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
	//   
	struct	tm*	newtime;
	time_t	aclock,start_time,finish_time;
	double	work_time;
	int		min,sec;
	char*	name="";
	
	
	time(&start_time);	// 

	//     D:		
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
		goto label_clock;

	//     C:\\temp
	if((prterr=fopen("C:\\temp\\prterr.txt","w"))!=NULL)
		goto label_clock;


	uc1601("    ",1);
	return;

label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"\n <wcs_along_z_axis_32>	HAS STARTED		line=%d\n",__LINE__);
	
	fprintf(prterr,"\n    :	%s\n\n",asctime(newtime));


    errorCode=UF_initialize();PRTERR;

		
	//     
	parent_part=UF_PART_ask_display_part();
	if(parent_part==NULL_TAG)
	{
		uc1601("  UG",1);
		fprintf(prterr,"\n	H  	UG line=%d\n",__LINE__);
		goto term;
	}


	do_it();
fprintf(prterr,"\n	 do_it()\n");

	errorCode=UF_terminate();PRTERR;
	fprintf(prterr,"\n	 UF_terminate()\n");
	
term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"\n <wcs_along_z_axis_32>	HAS FINISHED	line=%d\n",__LINE__);
	fprintf(prterr,"\n working time is %u min   %u sec\n",min,sec);

	fflush(prterr);
	fclose(prterr);
	
}

/*****************************************************************************
**  Utilities
*****************************************************************************/
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}